var QuickReferenceTable = '		<table cellspacing="0" summary="Regular expressions reference">\
			<tbody>\
				<tr>\
					<td colspan="2" style="color:#dc143c;line-height:250%">本ツールで使用できる正規表現 (Perlの正規表現の一部，対象: ASCIIテキスト)</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>.</code></td>\
					<td>改行以外の文字 (sオプションで改行にもマッチ)</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>\\.</code></td>\
					<td>ピリオド (メタキャラクターのエスケープ, <code>\\*</code>, <code>\\(</code>, <code>\\\\</code> なども同様)</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>^</code></td>\
					<td>文字列先頭 (mオプションで行頭)</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>$</code></td>\
					<td>文字列末 (mオプションで行末)</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>\\d</code>,<code>\\w</code>,<code>\\s</code></td>\
					<td>数字，単語構成文字 (=<code>[A-Za-z0-9_]</code>), スペース類.</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>\\D</code>,<code>\\W</code>,<code>\\S</code></td>\
					<td>上記の文字クラスの補集合</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>[</code><em>xyz</em><code>]</code></td>\
					<td>x, y, z のうちのどれか1文字 (文字クラス)</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>[</code><em>a</em><code>-</code><em>z</em><code>]</code></td>\
					<td>a から z までの範囲の1文字 (文字クラス)</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>[^</code><em>xyz</em><code>]</code></td>\
					<td>x, y, z 以外の文字 (文字クラスの補集合)</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><em>xx</em><code>|</code><em>yy</em></td>\
					<td>xx または yy (論理和)</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>?</code></td>\
					<td>直前のパターンの0回または1回の繰り返し</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>*</code></td>\
					<td>直前のパターンの0回以上の繰り返し</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>+</code></td>\
					<td>直前のパターンの1回以上の繰り返し</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>{</code><em>n</em><code>}</code></td>\
					<td>直前のパターンの<em>n</em>回の繰り返し</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>{</code><em>n</em><code>,}</code></td>\
					<td>直前のパターンの<em>n</em>回以上の繰り返し</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>{</code><em>m</em><code>,</code><em>n</em><code>}</code></td>\
					<td>直前のパターンの<em>m</em>回以上，<em>n</em>回以下の繰り返し</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>??</code>,<code>*?</code>,<code>+?</code>,<br/><code>{</code><em>n</em></code>}?</code>, など</td>\
					<td>直前のパターンの0回または1回，0回以上，1回以上，<br/><em>m</em>回以上<em>n</em>回以下の繰り返し (最短一致)</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>(</code><em>pattern</em><code>)</code></td>\
					<td><em>pattern</em>をグループ化し，マッチした文字列をキャプチャー (<code>\\1</code>, ... で参照)</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>(?:</code><em>pattern</em><code>)</code></td>\
					<td>キャプチャーなしのグループ化</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>(?=</code><em>pattern</em><code>)</code></td>\
					<td><em>pattern</em>が後続する位置 (先読み)</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>(?!</code><em>pattern</em><code>)</code></td>\
					<td><em>pattern</em>が後続しない位置 (先読み)</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><span style="color:gray"><code>(?&lt;=</code><em>pattern</em><code>)</code></span></td>\
					<td><em>pattern</em>が先行する位置 (後読み)：使用できません</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><span style="color:gray"><code>(?&lt;!</code><em>pattern</em><code>)</code></span></td>\
					<td><em>pattern</em>が先行しない位置 (後読み)：使用できません</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><span style="color:gray"><code>(?</code><em>option</em><code>:</code><em>pattern</em><code>)</code></span></td>\
					<td>正規表現内での<em>option</em>の指定：使用できません</td>\
				</tr>\
				<tr class="altBg" onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><span style="color:gray"><code>\\A</code>,<code>\\Z</code>,<code>\\z</code></span></td>\
					<td>文字列の先頭，末尾：使用できません</td>\
				</tr>\
				<tr onMouseOver="this.style.color=\'red\'" onMouseOut="this.style.color=\'black\'">\
					<td><code>\\n</code>, <code>\\x0a</code>; <code>\\r</code>, <code>\\x0d</code></td>\
					<td>改行，復帰にマッチ。但し，実際の解釈はブラウザーに依る。</td>\
				</tr>\
				</tbody>\
		</table>\
';

function showQuickReferenceTable() {
	var win = window.open("", "win4QuickReferenceTable", "width=730, height=650, resizable=yes, location=no, menubar=no");
	win.document.open();
	win.document.write('<html>\
<head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>\
<title>正規表現レファレンス</title>\
<style type="text/css">\
body           {font:13px/1.22;}\
table          {font-family:"ＭＳ 明朝";line-height:100%;}\
table          {background:#f0f8ff;}\
table tr.altBg {background:#e6e6fa;}\
code           {font-family:courier,monospace;}\
em             {font-family:Times,Times New Roman;font-style:italic;}\
</style>\
</head>\
<body>');
	win.document.write(QuickReferenceTable + '</body></html>');
	win.document.close();
}


function insertIndex(n) {

var index_items = [
["", "", ""], 
["3-1.html", "3.1", "リテラル，語の境界"], 
["3-2.html", "3.2", "論理和と範囲指定"], 
["3-3.html", "3.3", "任意の文字と文字クラス"], 
["3-4.html", "3.4", "量指定子 (繰り返し)"], 
["3-5.html", "3.5", "「任意の語」"], 
["3-6.html", "3.6", "「任意の語」"], 
["3-6d1.html", "3.6 演習3d1", "「任意の語」"], 
["3-6d2.html", "3.6 演習3d2", "「任意の語」"], 
["3-6d3.html", "3.6 演習3d3", "「任意の語」"], 
["3-7.html", "3.7", "「任意の語」の語数の指定"], 
["3-7e1ab.html", "3.7 演習3e1 a, b", "「任意の語」の語数の指定"], 
["3-7e1c.html", "3.7 演習3e1 c", "「任意の語」の語数の指定"], 
["3-7e2a.html", "3.7 演習3e2 a", "「任意の語」の語数の指定"], 
["3-7e2b.html", "3.7 演習3e2 b", "「任意の語」の語数の指定"], 
["3-7f.html", "3.7 演習3f", "「任意の語」の語数の指定"], 
["3-8.html", "3.8", "メタキャラクターのエスケープ"], 
["3-9.html", "3.9", "検索の単位と制御文字，位置"], 
["3-10ab.html", "3.10 a, b", "正規表現によるパターンの指定の例"], 
["3-10c.html", "3.10 c", "正規表現によるパターンの指定の例"], 
["3-10d.html", "3.10 d", "正規表現によるパターンの指定の例"], 
["3-10e.html", "3.10 e", "正規表現によるパターンの指定の例"], 
["3-10f.html", "3.10 f", "正規表現によるパターンの指定の例"], 
["4-1.html", "4.1", "最長一致・最短一致"], 
["4-2.html", "4.2", "選択要素間の優先順序"], 
["4-3.html", "4.3", "文字クラス内でのエスケープ"], 
["4-5_1.html", "4.5 (1)", "後方参照 (タグ付き正規表現)"], 
["4-5_2.html", "4.5 (2)", "後方参照 (タグ付き正規表現)"], 
["4-5c1.html", "4.5 演習4c 1", "後方参照 (タグ付き正規表現)"], 
["4-5c23.html", "4.5 演習4c 2, 3", "後方参照 (タグ付き正規表現)"], 
["4-7.html", "4.7", "4.7 レコードセパレータとレコード，ピリオドがマッチする文字"], 
["4-8.html", "4.8", "「段落」処理における ^ $ の解釈"], 
["4-9.html", "4.9", "語間の指定"], 
["4-10.html", "4.10", "文字クラスの否定と改行"], 
["4-11.html", "4.11", "文字列の先読み"], 
["4-12.html", "4.12", "文字クラスの否定と否定の先読み"], 
["", "", ""]
];

var goto;
if ( n == 1 ){ 
   goto = '<font color="gray">戻る</font>　<a href="' + index_items[n+1][0] + '">次へ</a>'
}
else if ( n == index_items.length-2 ){ 
   goto = '<a href="' + index_items[n-1][0] + '">戻る</a>　<font color="gray">次へ</font>'
}
else {
   goto = '<a href="' + index_items[n-1][0] + '">戻る</a>　<a href="' + index_items[n+1][0] + '">次へ</a>'
}

document.write('<div id="header">\n<h1>正規表現練習ページ</h1>\n');
document.write('<div style="margin-left:200px; margin-top:3px">　' + goto + '\n');
document.write('<select id="index" onChange="window.location=this.options[this.selectedIndex].value">\n');
for ( var i=0; i < index_items.length; i++ ){
	var t;
	if( i == n ){
		t = '<option selected value="' + index_items[i][0] + '" title="' + index_items[i][2] + '">' + index_items[i][1] + '</option>';
	}
	else {
		t = '<option value="' + index_items[i][0] + '" title="' + index_items[i][2] + '">' + index_items[i][1] + '</option>';
	}
	document.write( t + "\n");
}

document.write('</select>　\n');

document.write('<a href="' + index_items[n][0] + '" target=_blank title="マッチする個所の比較のためにウィンドウを複数開く時に利用します">新規ウィンドウ</a>　\n');

document.write('\n<select onChange="document.getElementsByTagName(\'textarea\')[0].focus();document.getElementsByTagName(\'textarea\')[0].value=this.options[this.selectedIndex].value;RegexPal.highlightSearchSyntax()">\n<option value="">正規表現を選択して挿入</option>');

}

function insertOptions() {
var search_and_display_options;

search_and_display_options = '	<div id="options">\
	<ul>\
	<li><span style="color:blue">検索オプション：</span> <input id="flagG" type="checkbox" checked="checked"/><label for="flagG" title="オフにすると最初のものにのみマッチします">全てにマッチ</label> <span class="flag" title="global">(g)</span>　\
	<input id="flagI" type="checkbox" checked="checked"/><label for="flagI" title="大文字と小文字を区別せずにマッチングを行います">大小を区別しない</label> <span class="flag" title="case-insensitive">(i)</span>　\
			<input id="flagM" type="checkbox" checked="checked"/><label for="flagM" title="オフだと文字列先頭と末尾にマッチします">^ $ が行頭・行末にマッチ</label> <span class="flag" title="multi-line mode">(m)</span>　\
			<input id="flagS" type="checkbox"/><label for="flagS" title="オンにすると，デフォルトではマッチしない改行にも . がマッチします">. が全ての文字にマッチ</label> <span class="flag" title="single-line mode">(s)</span>\
			</li>\
	</div>\
	<div id="options">\
		<ul>\
		<li>\
		<span style="color:blue">表示オプション：</span> <input id="highlightSyntax" type="checkbox" checked="checked"/><label for="highlightSyntax" title="正規表現の文法をチェックし，メタ文字などをハイライトします">文法をチェック</label>　<input id="highlightMatches" type="checkbox" checked="checked"/><label for="highlightMatches" title="下のテキストエリアのテキストで正規表現にマッチする個所をハイライトします">マッチした個所を強調表示</label>　<input id="invertMatches" type="checkbox"/><label for="invertMatches" title="マッチしない個所をハイライトします">結果を反転</label>　<input type="button" value=" CHECK " onClick="RegexPal.highlightSearchSyntax();RegexPal.highlightMatches();" title="[正規表現を選択して挿入] した時に，マッチする個所をハイライトするのに使用します" /></li>\
		<li class="optGroup" id="quickReferenceDropdown"><span style="color:blue;">有効な正規表現</span></li>\
		</ul>\
		</div>\
\
	<div id="quickReference" class="hidden">\
		<h2>JavaScript Regex Quick Reference</h2>\
		<span style="font-size:80%;cursor:pointer" onClick="showQuickReferenceTable();" onMouseOver="this.style.color=\'red\';"; onMouseOut="this.style.color=\'black\';">＜別ウィンドウに表示＞</span>\
		<img src="./assets/pin.gif" class="pin" alt="pin" title="pin"/>\
		<img src="./assets/close.gif" class="close" alt="close" title="close"/>\
' + QuickReferenceTable + '</div>\n';

document.write('</select>\n</div>\n</div>\n');
document.write(search_and_display_options);
document.write('<div id="body"><div id="search" class="smartField"><textarea cols="100" rows="3" tabindex="1" spellcheck="false">ここに正規表現を入力します</textarea></div>');
document.write('<div id="input" class="smartField">\n<textarea cols="100" rows="10" tabindex="2">');
}


function insertFooter() {
	document.write('</div></div><script src="./assets/build-0.1.4.js"></script>\n');
	document.write('<div align="center">Powered by <a href="http://regexpal.com/" target=_blank>RegexPal</a></div>\n');
}


